<?php

namespace Teknisa\CTB\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\CTB\Factories\Ctb17000RelatorioRazaoContrapartidaFactory;

class Ctb17000RelatorioRazaoContrapartidaService {

    protected $entityManager;
    protected $ctb17000RelatorioRazaoContrapartidaFactory;
    
    /**
     * @param EntityManager $entityManager
     * @param Ctb17000RelatorioRazaoContrapartidaFactory $ctb17000RelatorioRazaoContrapartidaFactory
     */
    public function __construct(EntityManager $entityManager, Ctb17000RelatorioRazaoContrapartidaFactory $ctb17000RelatorioRazaoContrapartidaFactory) {
        $this->entityManager = $entityManager;
        $this->ctb17000RelatorioRazaoContrapartidaFactory  = $ctb17000RelatorioRazaoContrapartidaFactory;
    }

    /**
     * Gera Razão Oficial
     * @param $cdempresa
     * @param $cdcontini
     * @param $cdcontfin
     * @param $dtinicial
     * @param $dtfinal
     * @param $relesp
     */
    public function geraRazaoOficial(
        $cdempresa, $cdcontini, $cdcontfin, $dtinicial, $dtfinal, $relesp
    ) {
       try {
            /* Executa Procedure RAZAO_OFICIAL */
            $nrrazao = $this->ctb17000RelatorioRazaoContrapartidaFactory->execProcRazaoOficial(
                $cdempresa, $cdcontini, $cdcontfin, $dtinicial, $dtfinal, $relesp
            );
            
            return $nrrazao;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}